<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/C/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/C/__init__.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/C/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">import</span> ParserImpl</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">import</span> os, os.path, tempfile</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/C/C/Parser.html">Parser</a>(Processor):</span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    preprocess = Parameter(True, <span class="py-string">'whether or not to preprocess the input'</span>)</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    emulate_compiler = Parameter(<span class="py-string">'cc'</span>, <span class="py-string">'a compiler to emulate'</span>)</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    compiler_flags = Parameter([], <span class="py-string">'list of flags for the emulated compiler'</span>)</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">    cppflags = Parameter([], <span class="py-string">'list of preprocessor flags such as -I or -D'</span>)</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">    primary_file_only = Parameter(True, <span class="py-string">'should only primary file be processed'</span>)</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">    base_path = Parameter(<span class="py-string">''</span>, <span class="py-string">'path prefix to strip off of the file names'</span>)</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">    sxr_prefix = Parameter(None, <span class="py-string">'path prefix (directory) to contain syntax info'</span>)</span>
<a id="line22"></a><span class="lineno">22</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/C/C/Parser.html#process">process</a>(self, ir, **kwds):</span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.input: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'input'</span>)</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        self.ir = ir</span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        <span class="py-keyword">if</span> self.preprocess:</span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">            <span class="py-keyword">from</span> Synopsis.Parsers <span class="py-keyword">import</span> Cpp</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">            cpp = Cpp.Parser(base_path = self.base_path,</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">                             language = <span class="py-string">'C'</span>,</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">                             flags = self.cppflags,</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">                             emulate_compiler = self.emulate_compiler,</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">                             compiler_flags = self.compiler_flags)</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        base_path = self.base_path <span class="py-keyword">and</span> os.path.abspath(self.base_path) + os.sep <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line39"></a><span class="lineno">39</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        <span class="py-keyword">for</span> file <span class="py-keyword">in</span> self.input:</span>
<a id="line41"></a><span class="lineno">41</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">            i_file = file</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">            <span class="py-keyword">if</span> self.preprocess:</span>
<a id="line44"></a><span class="lineno">44</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">                <span class="py-keyword">if</span> self.output:</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">                    i_file = os.path.splitext(self.output)[0] + <span class="py-string">'.i'</span></span>
<a id="line47"></a><span class="lineno">47</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">                    i_file = os.path.join(tempfile.gettempdir(),</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">                                          <span class="py-string">'synopsis-%s.i'</span>%os.getpid())</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">                self.ir = cpp.process(self.ir,</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">                                      cpp_output = i_file,</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">                                      input = [file],</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">                                      primary_file_only = self.primary_file_only,</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">                                      verbose = self.verbose,</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">                                      debug = self.debug)</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">            <span class="py-keyword">try</span>:</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">                self.ir = ParserImpl.parse(self.ir, i_file,</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">                                           os.path.abspath(file),</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">                                           self.primary_file_only,</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">                                           base_path,</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">                                           self.sxr_prefix,</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">                                           self.verbose,</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">                                           self.debug)</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">            <span class="py-keyword">finally</span>:</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">                <span class="py-keyword">if</span> self.preprocess: os.remove(i_file)</span>
<a id="line66"></a><span class="lineno">66</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line68"></a><span class="lineno">68</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
